
#ifndef __NETWORK_IMPLEMENTATION__H
#define __NETWORK_IMPLEMENTATION__H

struct TPacketInfo;
typedef struct TPacketInfo *PPacketInfo;
struct TPacketInfo
{
    TUnsignedInteger8 SourceIP[4];
    TUnsignedInteger8 DestinationIP[4];
    TUnsignedInteger16 SourcePort;
    TUnsignedInteger16 DestinationPort;
};

void InitNetwork(TPointer DataBuffer,TPointer OwnMAC,TPointer OwnIP,TPointer GatewayMAC);
void InitPacketWriter(PPacketInfo PacketInformation,PPacketWriter Writer);
PChar GetDataLocation(void);
void SendPacket(TUnsignedInteger16 Len);
TBoolean ReceivePacket(PPacketInfo PacketInformation,PPacketReader Reader);

#endif
