
#include "System.h"

#define _CRT_SECURE_NO_DEPRECATE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#ifdef _PC_

#ifdef __linux__

#define _LARGEFILE64_SOURCE

#include "System.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <fcntl.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h> 
#include <netdb.h>
#include <errno.h>

#include <curses.h>

typedef int DWORD;
typedef int SOCKET;

#elif defined(_WIN32)

#define _CRT_SECURE_NO_DEPRECATE
#include "System.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <conio.h>

#include "pdcurse//curses.h"
#pragma comment(lib,"Surse//pdcurse//pdcurses.lib")

#else

#endif

#if defined(_WIN32)

#undef MOUSE_MOVED

#include <WinSock2.h>
#include <ws2tcpip.h>
#pragma comment(lib,"ws2_32.lib")

#endif

#else

#include <stdlib.h>
#include <string.h>
#include <math.h>

#endif

#ifdef _PC_

//Transforma un input primit de la tastatura intr-o tasta care este folosita de program
TKeyboardKey InternalIntToKey(TInteger K)
{
 switch (K)
  {
   case 'a' :
     {
      return kkA;
     }
    break;
   case 'A' :
     {
      return kkAA;
     }
    break;
   case 'b' :
     {
      return kkB;
     }
    break;
   case 'B' :
     {
      return kkBB;
     }
    break;
   case 'c' :
     {
      return kkC;
     }
    break;
   case 'C' :
     {
      return kkCC;
     }
    break;
   case 'd' :
     {
      return kkD;
     }
    break;
   case 'D' :
     {
      return kkDD;
     }
    break;
   case 'e' :
     {
      return kkE;
     }
    break;
   case 'E' :
     {
      return kkEE;
     }
    break;
   case 'f' :
     {
      return kkF;
     }
    break;
   case 'F' :
     {
      return kkFF;
     }
    break;
   case 'g' :
     {
      return kkG;
     }
    break;
   case 'G' :
     {
      return kkGG;
     }
    break;
   case 'h' :
     {
      return kkH;
     }
    break;
   case 'H' :
     {
      return kkHH;
     }
    break;
   case 'i' :
     {
      return kkI;
     }
    break;
   case 'I' :
     {
      return kkII;
     }
    break;
   case 'j' :
     {
      return kkJ;
     }
    break;
   case 'J' :
     {
      return kkJJ;
     }
    break;
   case 'k' :
     {
      return kkK;
     }
    break;
   case 'K' :
     {
      return kkKK;
     }
    break;
   case 'l' :
     {
      return kkL;
     }
    break;
   case 'L' :
     {
      return kkLL;
     }
    break;
   case 'm' :
     {
      return kkM;
     }
    break;
   case 'M' :
     {
      return kkMM;
     }
    break;
   case 'n' :
     {
      return kkN;
     }
    break;
   case 'N' :
     {
      return kkNN;
     }
    break;
   case 'o' :
     {
      return kkO;
     }
    break;
   case 'O' :
     {
      return kkOO;
     }
    break;
   case 'p' :
     {
      return kkP;
     }
    break;
   case 'P' :
     {
      return kkPP;
     }
    break;
   case 'q' :
     {
      return kkQ;
     }
    break;
   case 'Q' :
     {
      return kkQQ;
     }
    break;
   case 'r' :
     {
      return kkR;
     }
    break;
   case 'R' :
     {
      return kkRR;
     }
    break;
   case 's' :
     {
      return kkS;
     }
    break;
   case 'S' :
     {
      return kkSS;
     }
    break;
   case 't' :
     {
      return kkT;
     }
    break;
   case 'T' :
     {
      return kkTT;
     }
    break;
   case 'u' :
     {
      return kkU;
     }
    break;
   case 'U' :
     {
      return kkUU;
     }
    break;
   case 'v' :
     {
      return kkV;
     }
    break;
   case 'V' :
     {
      return kkVV;
     }
    break;
   case 'w' :
     {
      return kkW;
     }
    break;
   case 'W' :
     {
      return kkWW;
     }
    break;
   case 'x' :
     {
      return kkX;
     }
    break;
   case 'X' :
     {
      return kkXX;
     }
    break;
   case 'y' :
     {
      return kkY;
     }
    break;
   case 'Y' :
     {
      return kkYY;
     }
    break;
   case 'z' :
     {
      return kkZ;
     }
    break;
   case 'Z' :
     {
      return kkZZ;
     }
    break;
   case '0' :
     {
      return kk0;
     }
    break;
   case '1' :
     {
      return kk1;
     }
    break;
   case '2' :
     {
      return kk2;
     }
    break;
   case '3' :
     {
      return kk3;
     }
    break;
   case '4' :
     {
      return kk4;
     }
    break;
   case '5' :
     {
      return kk5;
     }
    break;
   case '6' :
     {
      return kk6;
     }
    break;
   case '7' :
     {
      return kk7;
     }
    break;
   case '8' :
     {
      return kk8;
     }
    break;
   case '9' :
     {
      return kk9;
     }
    break;
   case ')' :
     {
      return kkRightParantheses;
     }
    break;
   case '!' :
     {
      return kkExclamation;
     }
    break;
   case '@' :
     {
      return kkAt;
     }
    break;
   case '#' :
     {
      return kkHash;
     }
    break;
   case '$' :
     {
      return kkDollar;
     }
    break;
   case '%' :
     {
      return kkProcent;
     }
    break;
   case '^' :
     {
      return kkCaret;
     }
    break;
   case '&' :
     {
      return kkAnd;
     }
    break;
   case '*' :
     {
      return kkAsterisk;
     }
    break;
   case '(' :
     {
      return kkLeftParantheses;
     }
    break;
   case ' ' :
     {
      return kkSpace;
     }
    break;
   case 8 :
   case KEY_BACKSPACE :
     {
      return kkBackSpace;
     }
    break;
   case 9 :
     {
      return kkTab;
     }
    break;
   case 10 :
     {
      return kkEnter;
     }
    break;
   case KEY_UP :
     {
      return kkUpArrow;
     }
    break;
   case KEY_DOWN :
     {
      return kkDownArrow;
     }
    break;
   case KEY_LEFT :
     {
      return kkLeftArrow;
     }
    break;
   case KEY_RIGHT :
     {
      return kkRightArrow;
     }
    break;
   case ',' :
     {
      return kkComma;
     }
    break;
   case '.' :
     {
      return kkPeriod;
     }
    break;
   case '<' :
     {
      return kkLower;
     }
    break;
   case '>' :
     {
      return kkBigger;
     }
    break;
   case '/' :
     {
      return kkSlash;
     }
    break;
   case '?' :
     {
      return kkQuestion;
     }
    break;
   case '|' :
     {
      return kkPipe;
     }
    break;
   case '\\' :
     {
      return kkBackslash;
     }
    break;
   case ':' :
     {
      return kkColon;
     }
    break;
   case ';' :
     {
      return kkSemicolon;
     }
    break;
   case '"' :
     {
      return kkQuote;
     }
    break;
   case '\'' :
     {
      return kkApostrophe;
     }
    break;
   case '{' :
     {
      return kkLeftBrace;
     }
    break;
   case '[' :
     {
      return kkLeftBracket;
     }
    break;
   case '}' :
     {
      return kkRightBrace;
     }
    break;
   case ']' :
     {
      return kkRightBracket;
     }
    break;
   case '_' :
     {
      return kkUnderScore;
     }
    break;
   case '-' :
     {
      return kkMinus;
     }
    break;
   case '=' :
     {
      return kkEqual;
     }
    break;
   case '+' :
     {
      return kkPlus;
     }
    break;
   case '`' :
     {
      return kkPrime;
     }
    break;
   case '~' :
     {
      return kkTilde;
     }
    break;
   case 27 :
     {
      return kkEsc;
     }
    break;
   case KEY_END :
     {
      return kkEnd;
     }
    break;
   case KEY_HOME :
     {
      return kkHome;
     }
    break;
   case KEY_PPAGE :
     {
      return kkPageUp;
     }
    break;
   case KEY_NPAGE :
     {
      return kkPageDown;
     }
    break;
   case KEY_IC :
     {
      return kkInsert;
     }
    break;
   case KEY_DC :
     {
      return kkDelete;
     }
    break;
  };
 return kkNone;
}

//Intoarce caracterul ASCII al tastei, daca exista
TChar KeyToChar(TKeyboardKey KK)
{
 if (KK == kkA)
   {
    return 'a';
   }
 if (KK == kkB)
   {
    return 'b';
   }
 if (KK == kkC)
   {
    return 'c';
   }
 if (KK == kkD)
   {
    return 'd';
   }
 if (KK == kkE)
   {
    return 'e';
   }
 if (KK == kkF)
   {
    return 'f';
   }
 if (KK == kkG)
   {
    return 'g';
   }
 if (KK == kkH)
   {
    return 'h';
   }
 if (KK == kkI)
   {
    return 'i';
   }
 if (KK == kkJ)
   {
    return 'j';
   }
 if (KK == kkK)
   {
    return 'k';
   }
 if (KK == kkL)
   {
    return 'l';
   }
 if (KK == kkM)
   {
    return 'm';
   }
 if (KK == kkN)
   {
    return 'n';
   }
 if (KK == kkO)
   {
    return 'o';
   }
 if (KK == kkP)
   {
    return 'p';
   }
 if (KK == kkQ)
   {
    return 'q';
   }
 if (KK == kkR)
   {
    return 'r';
   }
 if (KK == kkS)
   {
    return 's';
   }
 if (KK == kkT)
   {
    return 't';
   }
 if (KK == kkU)
   {
    return 'u';
   }
 if (KK == kkV)
   {
    return 'v';
   }
 if (KK == kkW)
   {
    return 'w';
   }
 if (KK == kkX)
   {
    return 'x';
   }
 if (KK == kkY)
   {
    return 'y';
   }
 if (KK == kkZ)
   {
    return 'z';
   }
 if (KK == kkAA)
   {
    return 'A';
   }
 if (KK == kkBB)
   {
    return 'B';
   }
 if (KK == kkCC)
   {
    return 'C';
   }
 if (KK == kkDD)
   {
    return 'D';
   }
 if (KK == kkEE)
   {
    return 'E';
   }
 if (KK == kkFF)
   {
    return 'F';
   }
 if (KK == kkGG)
   {
    return 'G';
   }
 if (KK == kkHH)
   {
    return 'H';
   }
 if (KK == kkII)
   {
    return 'I';
   }
 if (KK == kkJJ)
   {
    return 'J';
   }
 if (KK == kkKK)
   {
    return 'K';
   }
 if (KK == kkLL)
   {
    return 'L';
   }
 if (KK == kkMM)
   {
    return 'M';
   }
 if (KK == kkNN)
   {
    return 'N';
   }
 if (KK == kkOO)
   {
    return 'O';
   }
 if (KK == kkPP)
   {
    return 'P';
   }
 if (KK == kkQQ)
   {
    return 'Q';
   }
 if (KK == kkRR)
   {
    return 'R';
   }
 if (KK == kkSS)
   {
    return 'S';
   }
 if (KK == kkTT)
   {
    return 'T';
   }
 if (KK == kkUU)
   {
    return 'U';
   }
 if (KK == kkVV)
   {
    return 'V';
   }
 if (KK == kkWW)
   {
    return 'W';
   }
 if (KK == kkXX)
   {
    return 'X';
   }
 if (KK == kkYY)
   {
    return 'Y';
   }
 if (KK == kkZZ)
   {
    return 'Z';
   }
 if (KK == kk0)
   {
    return '0';
   }
 if (KK == kk1)
   {
    return '1';
   }
 if (KK == kk2)
   {
    return '2';
   }
 if (KK == kk3)
   {
    return '3';
   }
 if (KK == kk4)
   {
    return '4';
   }
 if (KK == kk5)
   {
    return '5';
   }
 if (KK == kk6)
   {
    return '6';
   }
 if (KK == kk7)
   {
    return '7';
   }
 if (KK == kk8)
   {
    return '8';
   }
 if (KK == kk9)
   {
    return '9';
   }
 if (KK == kkRightParantheses)
   {
    return ')';
   }
 if (KK == kkExclamation)
   {
    return '!';
   }
 if (KK == kkAt)
   {
    return '@';
   }
 if (KK == kkHash)
   {
    return '#';
   }
 if (KK == kkDollar)
   {
    return '$';
   }
 if (KK == kkProcent)
   {
    return '%';
   }
 if (KK == kkCaret)
   {
    return '^';
   }
 if (KK == kkAnd)
   {
    return '&';
   }
 if (KK == kkAsterisk)
   {
    return '*';
   }
 if (KK == kkLeftParantheses)
   {
    return '(';
   }
 if (KK == kkSpace)
   {
    return ' ';
   }
 if (KK == kkComma)
   {
    return ',';
   }
 if (KK == kkPeriod)
   {
    return '.';
   }
 if (KK == kkLower)
   {
    return '<';
   }
 if (KK == kkBigger)
   {
    return '>';
   }
 if (KK == kkSlash)
   {
    return '/';
   }
 if (KK == kkQuestion)
   {
    return '?';
   }
 if (KK == kkBackslash)
   {
    return '\\';
   }
 if (KK == kkPipe)
   {
    return '|';
   }
 if (KK == kkSemicolon)
   {
    return ';';
   }
 if (KK == kkColon)
   {
    return ':';
   }
 if (KK == kkApostrophe)
   {
    return '\'';
   }
 if (KK == kkQuote)
   {
    return '"';
   }
 if (KK == kkLeftBracket)
   {
    return '[';
   }
 if (KK == kkLeftBrace)
   {
    return '{';
   }
 if (KK == kkRightBracket)
   {
    return ']';
   }
 if (KK == kkRightBrace)
   {
    return '}';
   }
 if (KK == kkMinus)
   {
    return '-';
   }
 if (KK == kkUnderScore)
   {
    return '_';
   }
 if (KK == kkPlus)
   {
    return '+';
   }
 if (KK == kkEqual)
   {
    return '=';
   }
 if (KK == kkPrime)
   {
    return '`';
   }
 if (KK == kkTilde)
   {
    return '~';
   }
 return 0;
}

//Primeste codul ASCII si intoarce tasta care genereaza acel cod ASCII
TKeyboardKey CharToKey(TChar C)
{
 switch (C)
  {
   case 'a' :
     {
      return kkA;
     }
    break;
   case 'b' :
     {
      return kkB;
     }
    break;
   case 'c' :
     {
      return kkC;
     }
    break;
   case 'd' :
     {
      return kkD;
     }
    break;
   case 'e' :
     {
      return kkE;
     }
    break;
   case 'f' :
     {
      return kkF;
     }
    break;
   case 'g' :
     {
      return kkG;
     }
    break;
   case 'h' :
     {
      return kkH;
     }
    break;
   case 'i' :
     {
      return kkI;
     }
    break;
   case 'j' :
     {
      return kkJ;
     }
    break;
   case 'k' :
     {
      return kkK;
     }
    break;
   case 'l' :
     {
      return kkL;
     }
    break;
   case 'm' :
     {
      return kkM;
     }
    break;
   case 'n' :
     {
      return kkN;
     }
    break;
   case 'o' :
     {
      return kkO;
     }
    break;
   case 'p' :
     {
      return kkP;
     }
    break;
   case 'q' :
     {
      return kkQ;
     }
    break;
   case 'r' :
     {
      return kkR;
     }
    break;
   case 's' :
     {
      return kkS;
     }
    break;
   case 't' :
     {
      return kkT;
     }
    break;
   case 'u' :
     {
      return kkU;
     }
    break;
   case 'v' :
     {
      return kkV;
     }
    break;
   case 'w' :
     {
      return kkW;
     }
    break;
   case 'x' :
     {
      return kkX;
     }
    break;
   case 'y' :
     {
      return kkY;
     }
    break;
   case 'z' :
     {
      return kkZ;
     }
    break;
   case 'A' :
     {
      return kkAA;
     }
    break;
   case 'B' :
     {
      return kkBB;
     }
    break;
   case 'C' :
     {
      return kkCC;
     }
    break;
   case 'D' :
     {
      return kkDD;
     }
    break;
   case 'E' :
     {
      return kkEE;
     }
    break;
   case 'F' :
     {
      return kkFF;
     }
    break;
   case 'G' :
     {
      return kkGG;
     }
    break;
   case 'H' :
     {
      return kkHH;
     }
    break;
   case 'I' :
     {
      return kkII;
     }
    break;
   case 'J' :
     {
      return kkJJ;
     }
    break;
   case 'K' :
     {
      return kkKK;
     }
    break;
   case 'L' :
     {
      return kkLL;
     }
    break;
   case 'M' :
     {
      return kkMM;
     }
    break;
   case 'N' :
     {
      return kkNN;
     }
    break;
   case 'O' :
     {
      return kkOO;
     }
    break;
   case 'P' :
     {
      return kkPP;
     }
    break;
   case 'Q' :
     {
      return kkQQ;
     }
    break;
   case 'R' :
     {
      return kkRR;
     }
    break;
   case 'S' :
     {
      return kkSS;
     }
    break;
   case 'T' :
     {
      return kkTT;
     }
    break;
   case 'U' :
     {
      return kkUU;
     }
    break;
   case 'V' :
     {
      return kkVV;
     }
    break;
   case 'W' :
     {
      return kkWW;
     }
    break;
   case 'X' :
     {
      return kkXX;
     }
    break;
   case 'Y' :
     {
      return kkYY;
     }
    break;
   case 'Z' :
     {
      return kkZZ;
     }
    break;
   case '0' :
     {
      return kk0;
     }
    break;
   case '1' :
     {
      return kk1;
     }
    break;
   case '2' :
     {
      return kk2;
     }
    break;
   case '3' :
     {
      return kk3;
     }
    break;
   case '4' :
     {
      return kk4;
     }
    break;
   case '5' :
     {
      return kk5;
     }
    break;
   case '6' :
     {
      return kk6;
     }
    break;
   case '7' :
     {
      return kk7;
     }
    break;
   case '8' :
     {
      return kk8;
     }
    break;
   case '9' :
     {
      return kk9;
     }
    break;
   case ')' :
     {
      return kkRightParantheses;
     }
    break;
   case '!' :
     {
      return kkExclamation;
     }
    break;
   case '@' :
     {
      return kkAt;
     }
    break;
   case '#' :
     {
      return kkHash;
     }
    break;
   case '$' :
     {
      return kkDollar;
     }
    break;
   case '%' :
     {
      return kkProcent;
     }
    break;
   case '^' :
     {
      return kkCaret;
     }
    break;
   case '&' :
     {
      return kkAnd;
     }
    break;
   case '*' :
     {
      return kkAsterisk;
     }
    break;
   case '(' :
     {
      return kkLeftParantheses;
     }
    break;
   case ' ' :
     {
      return kkSpace;
     }
    break;
   case ',' :
     {
      return kkComma;
     }
    break;
   case '.' :
     {
      return kkPeriod;
     }
    break;
   case '<' :
     {
      return kkLower;
     }
    break;
   case '>' :
     {
      return kkBigger;
     }
    break;
   case '/' :
     {
      return kkSlash;
     }
    break;
   case '?' :
     {
      return kkQuestion;
     }
    break;
   case '\\' :
     {
      return kkBackslash;
     }
    break;
   case '|' :
     {
      return kkPipe;
     }
    break;
   case ';' :
     {
      return kkSemicolon;
     }
    break;
   case ':' :
     {
      return kkColon;
     }
    break;
   case '\'' :
     {
      return kkApostrophe;
     }
    break;
   case '"' :
     {
      return kkQuote;
     }
    break;
   case '[' :
     {
      return kkLeftBracket;
     }
    break;
   case '{' :
     {
      return kkLeftBrace;
     }
    break;
   case ']' :
     {
      return kkRightBracket;
     }
    break;
   case '}' :
     {
      return kkRightBrace;
     }
    break;
   case '-' :
     {
      return kkMinus;
     }
    break;
   case '_' :
     {
      return kkUnderScore;
     }
    break;
   case '+' :
     {
      return kkPlus;
     }
    break;
   case '=' :
     {
      return kkEqual;
     }
    break;
   case '`' :
     {
      return kkPrime;
     }
    break;
   case '~' :
     {
      return kkTilde;
     }
    break;
  };
 return 0;
}

TPointer OutputConsole = 0;

void ForceClose(TInteger Line,PChar File,PChar Message)
{
//Distruge consola, daca a fost creata
 if (OutputConsole != 0)
   {
    DestroyConsole();
   }
//Afiseaza eroarea
 printf("Assertion failure in file %s on line %lld : %s\n",File,Line,Message);
#ifdef __linux__
 printf("%d\n",errno);
#endif
//Inchide fortat programul
 abort();
}

void InitColors(void)
{
//Initializeaza culorile folosite in consola
 init_pair(0,COLOR_BLACK,COLOR_BLACK);
 init_pair(1,COLOR_RED,COLOR_BLACK);
 init_pair(2,COLOR_GREEN,COLOR_BLACK);
 init_pair(3,COLOR_YELLOW,COLOR_BLACK);
 init_pair(4,COLOR_BLUE,COLOR_BLACK);
 init_pair(5,COLOR_MAGENTA,COLOR_BLACK);
 init_pair(6,COLOR_CYAN,COLOR_BLACK);
 init_pair(7,COLOR_WHITE,COLOR_BLACK);
 init_pair(8,COLOR_BLACK,COLOR_RED);
 init_pair(9,COLOR_RED,COLOR_RED);
 init_pair(10,COLOR_GREEN,COLOR_RED);
 init_pair(11,COLOR_YELLOW,COLOR_RED);
 init_pair(12,COLOR_BLUE,COLOR_RED);
 init_pair(13,COLOR_MAGENTA,COLOR_RED);
 init_pair(14,COLOR_CYAN,COLOR_RED);
 init_pair(15,COLOR_WHITE,COLOR_RED);
 init_pair(16,COLOR_BLACK,COLOR_GREEN);
 init_pair(17,COLOR_RED,COLOR_GREEN);
 init_pair(18,COLOR_GREEN,COLOR_GREEN);
 init_pair(19,COLOR_YELLOW,COLOR_GREEN);
 init_pair(20,COLOR_BLUE,COLOR_GREEN);
 init_pair(21,COLOR_MAGENTA,COLOR_GREEN);
 init_pair(22,COLOR_CYAN,COLOR_GREEN);
 init_pair(23,COLOR_WHITE,COLOR_GREEN);
 init_pair(24,COLOR_BLACK,COLOR_YELLOW);
 init_pair(25,COLOR_RED,COLOR_YELLOW);
 init_pair(26,COLOR_GREEN,COLOR_YELLOW);
 init_pair(27,COLOR_YELLOW,COLOR_YELLOW);
 init_pair(28,COLOR_BLUE,COLOR_YELLOW);
 init_pair(29,COLOR_MAGENTA,COLOR_YELLOW);
 init_pair(30,COLOR_CYAN,COLOR_YELLOW);
 init_pair(31,COLOR_WHITE,COLOR_YELLOW);
 init_pair(32,COLOR_BLACK,COLOR_BLUE);
 init_pair(33,COLOR_RED,COLOR_BLUE);
 init_pair(34,COLOR_GREEN,COLOR_BLUE);
 init_pair(35,COLOR_YELLOW,COLOR_BLUE);
 init_pair(36,COLOR_BLUE,COLOR_BLUE);
 init_pair(37,COLOR_MAGENTA,COLOR_BLUE);
 init_pair(38,COLOR_CYAN,COLOR_BLUE);
 init_pair(39,COLOR_WHITE,COLOR_BLUE);
 init_pair(40,COLOR_BLACK,COLOR_MAGENTA);
 init_pair(41,COLOR_RED,COLOR_MAGENTA);
 init_pair(42,COLOR_GREEN,COLOR_MAGENTA);
 init_pair(43,COLOR_YELLOW,COLOR_MAGENTA);
 init_pair(44,COLOR_BLUE,COLOR_MAGENTA);
 init_pair(45,COLOR_MAGENTA,COLOR_MAGENTA);
 init_pair(46,COLOR_CYAN,COLOR_MAGENTA);
 init_pair(47,COLOR_WHITE,COLOR_MAGENTA);
 init_pair(48,COLOR_BLACK,COLOR_CYAN);
 init_pair(49,COLOR_RED,COLOR_CYAN);
 init_pair(50,COLOR_GREEN,COLOR_CYAN);
 init_pair(51,COLOR_YELLOW,COLOR_CYAN);
 init_pair(52,COLOR_BLUE,COLOR_CYAN);
 init_pair(53,COLOR_MAGENTA,COLOR_CYAN);
 init_pair(54,COLOR_CYAN,COLOR_CYAN);
 init_pair(55,COLOR_WHITE,COLOR_CYAN);
 init_pair(56,COLOR_BLACK,COLOR_WHITE);
 init_pair(57,COLOR_RED,COLOR_WHITE);
 init_pair(58,COLOR_GREEN,COLOR_WHITE);
 init_pair(59,COLOR_YELLOW,COLOR_WHITE);
 init_pair(60,COLOR_BLUE,COLOR_WHITE);
 init_pair(61,COLOR_MAGENTA,COLOR_WHITE);
 init_pair(62,COLOR_CYAN,COLOR_WHITE);
 init_pair(63,COLOR_WHITE,COLOR_WHITE);
}

TBoolean VerifyLongLong(void)
{
//Verifica daca long long este suportat de printf si scanf
 TChar X[21];
 TInteger N = 1234567890123456789LL;
 sprintf(X,"%lld",N);
 sscanf(X,"%lld",&N);
 if (N != 1234567890123456789LL)
   {
    return False;
   }
  else
   {
    return True;
   }
}

TInteger GenerateRandom(void)
{
//Genereaza un numar random pe 64 biti
 return (((TInteger)(rand())) << 32) + rand();
}

#endif

#ifdef _PC_

TPointer AllocateMemory(TInteger Size)
{
//Daca se doreste alocarea unui buffer de marimea 0 sau mai mica
 if (Size <= 0)
   {
//Se intoarce un pointer null
    return 0;
   }
  else
   {
//Altfel se aloca memoria
    TPointer P;
    P = malloc((size_t)(Size));
    DebugSystemAssert(P != 0,"Unable to allocate memory buffer.");
    return P;
   }
}

TPointer ReAllocateMemory(TPointer P,TInteger Size)
{
//Daca se doreste realocarea bufferului sa aiba marimea 0 sau negativa
 if (Size <= 0)
   {
//Este eliberat
    return FreeMemory(P);
   }
  else
   {
//Daca nu exista buffer alocat inainte
    if (P == 0)
      {
//Se aloca
       return AllocateMemory(Size);
      }
     else
      {
//Altfel se realoca
       P = realloc(P,(size_t)(Size));
       DebugSystemAssert(P != 0,"Unable to reallocate memory buffer.");
       return P;
      }
   }
}

TPointer FreeMemory(TPointer P)
{
//Elibereaza memoria
 free(P);
 return 0;
}

PChar CopyPCharBuffer(PChar From)
{
//Daca se doreste copia unui string care e nul
 if (From == 0)
   {
#if defined(_WIN32)
#pragma warning(disable:4996)
#endif
//Se creaza o copie vida
    return (PChar)(strdup(""));
#if defined(_WIN32)
#pragma warning(default:4996)
#endif
   }
  else
   {
#if defined(_WIN32)
#pragma warning(disable:4996)
#endif
//Se copiaza normal
    return (PChar)(strdup((PChar)(From)));
#if defined(_WIN32)
#pragma warning(default:4996)
#endif
   }
}

PChar CopyPCharBufferN(PChar From,TInteger Len)
{
//Aloca un buffer sa incapa caracterele
 PChar Result = (PChar)(AllocateMemory(Len + 1));
//Si se copiaza cate caractere sunt dorite
 StringCopyN(Result,From,Len);
 return Result;
}

#endif

void ZeroMemoryBuffer(TPointer P,TInteger Size)
{
//Sunt setati toti octetii pe 0
 memset(P,0,(size_t)(Size));
}

void CopyMemoryBuffer(TPointer To,TPointer From,TInteger Len)
{
//Copiaza bufferul de memorie
 memmove(To,From,(size_t)(Len));
}

#ifdef _PC_

void CreateConsole(void)
{
 WINDOW *wnd;
//Se verifica ca scanf si printf suporta long long
 DebugSystemAssert(VerifyLongLong() != False,
                   "Compile the project so that the 'long long' type has the size of 8 bytes and printf and scanf \
                    support '%%lld' to display 'long long' integers!");
//Se initializeaza generatorul de numere random
 srand((unsigned int)(time(0)));
//Se initializeaza consola
 wnd = initscr();
 DebugSystemAssert(wnd != 0,"Unable to create console.");
 OutputConsole = (TPointer)(wnd);
//Se initializeaza parametrii consolei
 curs_set(0);
 wclear(wnd);
 noecho();
 cbreak();
 nodelay(wnd,TRUE);
 keypad(wnd,TRUE);
 DebugSystemAssert(has_colors() != 0,"Console has no colors.");
 start_color();
 DebugSystemAssert((COLORS >= 8) && (COLOR_PAIRS >= 64),"Console doesn't support 8 colors or 64 pairs of colors.");
 InitColors();
 wattron(wnd,COLOR_PAIR(0));
}

void DestroyConsole(void)
{
//Este distrusa consola
 endwin();
}

void GetConsoleSize(PInteger X,PInteger Y)
{
//Sunt luate marimile consolei
 (*X) = getmaxx((WINDOW *)(OutputConsole));
 (*Y) = getmaxy((WINDOW *)(OutputConsole));
}

void GoToPosition(TInteger X,TInteger Y)
{
//Pozitioneaza cursorul
 wmove((WINDOW *)(OutputConsole),(int)(Y),(int)(X));
}

void SetColor(PConsoleColor Color)
{
//Sterge vechea culoare
 static TInteger Old = COLOR_PAIR(0);
 wattroff((WINDOW *)(OutputConsole),(chtype)(Old));
 Old = COLOR_PAIR(Color->Background * 8 + Color->Foreground);
//Pune noua culoare
 wattron((WINDOW *)(OutputConsole),(chtype)(Old));
}

void CreateColor(PConsoleColor C,TColor F,TColor B)
{
//Creaza culoarea
 C->Foreground = F;
 C->Background = B;
}

void WriteChar(TChar C)
{
//Scrie caracterul
 waddch((WINDOW *)(OutputConsole),C);
}

void WriteString(PChar S)
{
//Scrie stringul
 waddstr((WINDOW *)(OutputConsole),S);
}

void WriteStringN(PChar S,TInteger Len)
{
//Scrie un anumit numar de caractere
 waddnstr((WINDOW *)(OutputConsole),S,(int)(Len));
}

void WriteInteger(TInteger N)
{
//Scrie numarul intr-un buffer
 char S[30];
 sprintf(S,"%lld",N);
//Scrie bufferul care contine numarul
 waddstr((WINDOW *)(OutputConsole),S);
}

TKeyboardKey GetKeyPressed(void)
{
//Intoarce tasta apasata
 return InternalIntToKey(wgetch((WINDOW *)(OutputConsole)));
}

void ClearDisplay(TInteger MaxX,TInteger MaxY,PConsoleColor Color)
{
//Curata tot ecranul
 TInteger a,b;
 SetColor(Color);
 wmove((WINDOW *)(OutputConsole),0,0);
 for (a = 0;a < MaxY;a = a + 1)
  {
   for (b = 0;b < MaxX;b = b + 1)
    {
     WriteStringN(" ",1);
    }
  }
//Se pozitioneaza la inceput
 wmove((WINDOW *)(OutputConsole),0,0);
}

void ClearWindow(TInteger X1,TInteger Y1,TInteger X2,TInteger Y2,PConsoleColor Color)
{
//Sorteaza coordonatele patratului
 TInteger a,b;
 if (X2 < X1)
   {
    a = X1;
    X1 = X2;
    X2 = a;
   }
 if (Y2 < Y1)
   {
    a = Y1;
    Y1 = Y2;
    Y2 = a;
   }
//Curata patratul
 SetColor(Color);
 for (a = Y1;a <= Y2;a = a + 1)
  {
   for (b = X1;b < X2;b = b + 1)
    {
     wmove((WINDOW *)(OutputConsole),(int)(a),(int)(b));
     WriteStringN(" ",1);
    }
  }
//Se pozitioneaza la inceputul patratului
 wmove((WINDOW *)(OutputConsole),(int)(X1),(int)(Y1));
}

void UpdateDisplay(void)
{
//Trimite starea ecranului pentru a fi afisata
 wrefresh((WINDOW *)(OutputConsole));
}

#endif

void WaitNanoSeconds(TInteger Nanoseconds)
{
//Asteapta un anumit interval de timp
#ifdef __linux__
 struct timespec Total,Remaining;
 Total.tv_sec = Nanoseconds / 1000000000;
 Total.tv_nsec = Nanoseconds % 1000000000;
 Remaining.tv_sec = Total.tv_sec;
 Remaining.tv_nsec = Total.tv_nsec;
 while ((Remaining.tv_sec > 0) || (Remaining.tv_nsec > 0))
  {
   if (nanosleep(&Total,&Remaining) == 0)
     {
      break;
     }
   Total.tv_sec = Remaining.tv_sec;
   Total.tv_nsec = Remaining.tv_nsec;
  }
#elif defined(_WIN32)
#pragma warning(disable:4996)
 Nanoseconds /= 1000000;
 _sleep((unsigned long)(Nanoseconds));
#pragma warning(default:4996)
#endif
}

#ifdef _PC_

TInteger GetTime(void)
{
//Ia momentul de timp curent
#ifdef __linux__
 struct timeval tv;
 gettimeofday(&tv,0);
 return (((TInteger)(tv.tv_sec)) * 1000000000) + ((TInteger)(tv.tv_usec) * 1000000);
#elif defined(_WIN32)
/* time_t tt;
 struct tm abc;
 unsigned int a;
#pragma warning(disable:4996)
 a = _getsystime(&abc);
#pragma warning(default:4996)
 tt = mktime(&abc);
 return (((TInteger)(tt)) * 1000000000 + (TInteger)(a * 1000000));*/
 struct tm abc;
 struct TTimeMoment TM;
 unsigned int a;
#pragma warning(disable:4996)
 a = _getsystime(&abc);
#pragma warning(default:4996)
 TM.Year = abc.tm_year - 70 + 1970;
 TM.Month = abc.tm_mon + 1;
 TM.Day = abc.tm_mday;
 TM.Hour = abc.tm_hour;
 TM.Minute = abc.tm_min;
 TM.Second = abc.tm_sec;
 return GetTimeFromMoment(&TM);
#endif
}

TInteger8 LeapYear(TInteger16 Year)
{
    TInteger8 DN;
    DN = 0;
    if ((Year % 4) == 0)
    {
        DN = 1;
        if ((Year % 100) == 0)
        {
            DN = 0;
            if ((Year % 400) == 0)
            {
                DN = 1;
            }
        }
    }
    return DN;
}

TInteger GetTimeFromMoment(PTimeMoment M)
{
    TInteger Res = 0;
    TInteger16 Y;
    for (Y = 1970;Y < M->Year;Y += 1)
    {
        Res += (365 + LeapYear(Y)) * 24 * 60 * 60;
    }
    for (Y = 1;Y < M->Month;Y += 1)
    {
        TInteger8 MonLen[13] = {0,31,28 + LeapYear(M->Year),31,30,31,30,31,31,30,31,30,31};
        Res += MonLen[Y] * 24 * 60 * 60;
    }
    Res += (M->Day - 1) * 24 * 60 * 60;
    Res += M->Hour * 60 * 60;
    Res += M->Minute * 60;
    Res += M->Second;
    return Res;
}

void GetMomentFromTime(PTimeMoment M,TInteger T)
{
    TInteger V;
    static TInteger8 MonLen[13] = {0,31,28,31,30,31,30,31,31,30,31,30,31};

    M->Year = 1970;
    while (T > (V = ((365 + LeapYear(M->Year)) * 24 * 60 * 60)))
    {
        T -= V;
        M->Year += 1;
    }
    MonLen[2] = 28 + LeapYear(M->Year);

    M->Month = 1;
    while (T > (V = (MonLen[M->Year] * 24 * 60 * 60)))
    {
        T -= V;
        M->Month += 1;
    }

    M->Day = ((TInteger8)(1 + (T / (24 * 60 * 60))));
    T -= (M->Day - 1) * 24 * 60 * 60;

    M->Hour = ((TInteger8)(T / (60 * 60)));
    T -= M->Hour * 60 * 60;

    M->Minute = ((TInteger8)(T / 60));
    T -= M->Minute * 60;

    M->Second = ((TInteger8)(T));
}

#endif

PChar StringCopy(PChar To,PChar From)
{
//Copiaza stringul
 return strcpy(To,From);
}

PChar StringCopyN(PChar To,PChar From,TInteger Len)
{
//Copiaza stringul de o anumita lungime
 PChar Result = strncpy(To,From,(size_t)(Len));
//Pune sfarsitul stringului
 To[Len] = 0;
 return Result;
}

PChar StringCat(PChar To,PChar From)
{
//Concateneaza stringul
 return strcat(To,From);
}

PChar StringCatN(PChar To,PChar From,TInteger Len)
{
//Afla lungimea stringului initial
 TInteger Len1 = StringLength(To);
//Concateneaza stringul
 PChar Result = strncat(To,From,(size_t)(Len));
//Pune sfarsitul stringului
 Result[Len1 + Len] = 0;
 return Result;
}

TInteger StringCmp(PChar S1,PChar S2)
{
//Compara cele doua stringuri
 return strcmp(S1,S2);
}

TInteger StringCmpN(PChar S1,PChar S2,TInteger Len)
{
//Compara primele caractere din stringuri
 return strncmp(S1,S2,(size_t)(Len));
}

/*PChar IntToStr(TInteger T,PChar Dest)
{
//Calculez lungimea afisarii numarului
 TInteger a,c,sm;
 PChar S;
 if (T < 0)
   {
    sm = 1;
    a = -T;
   }
  else
   {
    sm = 0;
    a = T;
   }
 c = 0;
 while (a > 0)
  {
   a = a / 10;
   c = c + 1;
  }
 if (c == 0)
   {
    c = 1;
   }
//Aloca memoria
 S = (PChar)(AllocateMemory((c + sm + 1) * sizeof(TChar)));
//Scrie numarul
 if (S == 0)
   {
    return 0;
   }
  else
   {
    sprintf(S,"%lld",T);
   }
 return S;
}*/

TInteger StringLength(PChar S)
{
//Calculeaza lungimea stringului
 return strlen(S);
}

TBoolean StrToInt(PChar S,PInteger Out)
{
//Citeste numarul, si intoarce daca a putut sa citeasca
 return (sscanf(S,"%lld",Out) == 1);
}

#ifdef _PC_

struct TInternFile;
typedef struct TInternFile *PInternFile;
struct TInternFile
{
 TFileMode Mode;
#ifdef __linux__
 int Handle;
#endif
#ifdef _WIN32
 TPointer Handle;
#endif
};

TFile FileOpen(PChar FileName,TFileMode Mode)
{
//Deschide fisierul
#ifdef __linux__
 DWORD LinuxMode;
 switch (Mode)
  {
   case fmOpenReadOnly :
     {
      LinuxMode = O_RDONLY | O_LARGEFILE;
     }
    break;
   case fmOpenReadWrite :
     {
      LinuxMode = O_RDWR | O_LARGEFILE | O_CREAT;
     }
    break;
   case fmOpenTruncate :
     {
      LinuxMode = O_RDWR | O_LARGEFILE | O_CREAT | O_TRUNC;
     }
    break;
   default :
     {
      DebugSystemAssert(0,"Invalid file mode.");
     }
    break;
  }
 int FD = open(FileName,LinuxMode,0644);
 if (FD < 0)
   {
    return 0;
   }
 PInternFile File = (PInternFile)(AllocateMemory(sizeof(TInternFile)));
 File->Handle = FD;
 File->Mode = Mode;
 return File;
#endif
#ifdef _WIN32
 DWORD OT,RT,CT;
 TPointer P;
 PInternFile File;

 if (Mode == fmOpenReadOnly)
 {
      OT = GENERIC_READ;
      CT = OPEN_EXISTING;
      RT = FILE_SHARE_READ;
 }
 if (Mode == fmOpenReadWrite)
 {
      OT = GENERIC_READ | GENERIC_WRITE;
      CT = OPEN_ALWAYS;
      RT = 0;
 }
 if (Mode == fmOpenTruncate)
 {
      OT = GENERIC_READ | GENERIC_WRITE;
      CT = CREATE_ALWAYS;
      RT = 0;
 }

 P = CreateFile(FileName,OT,RT,0,CT,FILE_ATTRIBUTE_NORMAL,0);
 if ((P == 0) || (P == INVALID_HANDLE_VALUE))
   {
    return 0;
   }
 File = (PInternFile)(AllocateMemory(sizeof(struct TInternFile)));
 File->Handle = P;
 File->Mode = Mode;
 return File;
#endif
}

TInteger FileSetPosition(TFile File,TInteger Position)
{
//Ia pozitia din fisier
#ifdef _WIN32
 LARGE_INTEGER LI;
#endif
 PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
#ifdef __linux__
 return lseek64(F->Handle,Position,SEEK_SET);
#endif
#ifdef _WIN32
 LI.QuadPart = Position;
 LI.LowPart = SetFilePointer(F->Handle,LI.LowPart,&LI.HighPart,FILE_BEGIN);
 if ((LI.LowPart == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR))
   {
    LI.QuadPart = -1;
   }
 return LI.QuadPart;
#endif
}

TInteger FileGetPosition(TFile File)
{
//Seteaza pozitia in fisier
#ifdef _WIN32
 LARGE_INTEGER LI;
#endif
 PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
#ifdef __linux__
 return lseek64(F->Handle,0,SEEK_CUR);
#endif
#ifdef _WIN32
 LI.QuadPart = 0;
 LI.LowPart = SetFilePointer(F->Handle,LI.LowPart,&LI.HighPart,FILE_CURRENT);
 if ((LI.LowPart == INVALID_SET_FILE_POINTER) && (GetLastError() != NO_ERROR))
   {
    LI.QuadPart = -1;
   }
 return LI.QuadPart;
#endif
}

TInteger FileGetSize(TFile File)
{
//Ia marimea fisierului, fara sa modifice pozitia in fisier
#ifdef _WIN32
 LARGE_INTEGER LI;
#endif
 PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
#ifdef __linux__
 TInteger Pos = FileGetPosition(File);
 TInteger Result = lseek64(F->Handle,0,SEEK_END);
 FileSetPosition(File,Pos);
 return Result;
#endif
#ifdef _WIN32
 GetFileSizeEx(F->Handle,&LI);
 return LI.QuadPart;
#endif
}

TInteger FileSetSize(TFile File,TInteger Size)
{
//Seteaza marimea fisierului, fara sa modifice pozitia in fisier
#ifdef _WIN32
 TInteger CurrentPos,NewSize,Res;
#endif
 PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
 DebugSystemAssert(F->Mode != fmOpenReadOnly,"Unable to write read only file.");
#ifdef __linux__
 ftruncate64(F->Handle,Size);
 return FileGetSize(File);
#endif
#ifdef _WIN32
 CurrentPos = FileGetPosition(File);
 if (CurrentPos < 0)
   {
    return CurrentPos;
   }
 NewSize = FileSetPosition(File,Size);
 if (NewSize < 0)
   {
    return NewSize;
   }
 Res = SetEndOfFile(F->Handle);
 if (Res == 0)
   {
    return -1;
   }
 return FileGetSize(File);
#endif
}

TInteger FileRead(TFile File,TPointer Buffer,TInteger Size)
{
//Citeste incontinuu datele din fisier
#ifdef _WIN32
 TInteger HaveReadden = 0;
 DWORD Readden = 0;
 DWORD ToRead;
 TInteger Err;
#endif
    PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
#ifdef __linux__
 TInteger HaveReadden = 0;
 DWORD Readden = 0;
 DWORD ToRead;
 while (HaveReadden < Size)
  {
   ToRead = (DWORD)(Size);
   if (ToRead > 0X7FFFFFFF)
     {
      ToRead = 0X7FFFFFFF;
     }
   Readden = read(F->Handle,((PBuffer)(Buffer)) + HaveReadden,ToRead);
   if (Readden < 0)
     {
      return HaveReadden;
     }
   HaveReadden += Readden;
   Size -= Readden;
  }
 return HaveReadden;
#endif
#ifdef _WIN32
 while (HaveReadden < Size)
  {
   ToRead = (DWORD)(Size);
   if (ToRead > 0XFFFFFFFF)
     {
      ToRead = 0XFFFFFFFF;
     }
   Err = ReadFile(F->Handle,((PBuffer)(Buffer)) + HaveReadden,ToRead,&Readden,0);
   if (Err == 0)
     {
      return HaveReadden + Readden;
     }
   HaveReadden += Readden;
   Size -= Readden;
  }
 return HaveReadden;
#endif
}

TInteger FileWrite(TFile File,TPointer Buffer,TInteger Size)
{
//Scrie incontinuu datele in fisier
#ifdef _WIN32
 TInteger HaveWritten = 0;
 DWORD Written = 0;
 DWORD ToWrite;
 TInteger Err;
#endif
PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
 DebugSystemAssert(F->Mode != fmOpenReadOnly,"Unable to write read only file.");
#ifdef __linux__
 TInteger HaveWritten = 0;
 DWORD Written = 0;
 DWORD ToWrite;
 TInteger Err;
 while (HaveWritten < Size)
  {
   ToWrite = (DWORD)(Size);
   if (ToWrite > 0XFFFFFFFF)
     {
      ToWrite = 0XFFFFFFFF;
     }
   Written = write(F->Handle,((PBuffer)(Buffer)) + HaveWritten,ToWrite);
   if (Written < 0)
     {
      return HaveWritten;
     }
   HaveWritten += Written;
   Size -= Written;
  }
 return HaveWritten;
#endif
#ifdef _WIN32
 while (HaveWritten < Size)
  {
   ToWrite = (DWORD)(Size);
   if (ToWrite > 0XFFFFFFFF)
     {
      ToWrite = 0XFFFFFFFF;
     }
   Err = WriteFile(F->Handle,((PBuffer)(Buffer)) + HaveWritten,ToWrite,&Written,0);
   if (Err == 0)
     {
      return HaveWritten + Written;
     }
   HaveWritten += Written;
   Size -= Written;
  }
 return HaveWritten;
#endif
}

void FileFlush(TFile File)
{
//Forteaza sa fie scrie toate modificarile in fisier
PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
 DebugSystemAssert(F->Mode != fmOpenReadOnly,"Unable to write read only file.");
#ifdef __linux__
 fsync(F->Handle);
#endif
#ifdef _WIN32
 FlushFileBuffers(F->Handle);
#endif
}

void FileClose(TFile File)
{
//Inchide fisierul
PInternFile F;
 DebugSystemAssert(File != 0,"Invalid file.");
 F = (PInternFile)(File);
#ifdef __linux__
 close(F->Handle);
#endif
#ifdef _WIN32
 CloseHandle(F->Handle);
#endif
FreeMemory(F);
}

PWritingString CreateEmptyWritingString(TInteger MaxLen)
{
//Aloca memoria si initializeaza inputul
 PWritingString Result = (PWritingString)(AllocateMemory(sizeof(struct TWritingString)));
 Result->BuffSize = 1 << 8;
 Result->Len = 0;
 Result->Data = (PChar)(AllocateMemory(Result->BuffSize * sizeof(TChar)));
 Result->Data[0] = 0;
 Result->MaxLen = MaxLen;
 return Result;
}

void AppendCharToWritingString(PWritingString S,TChar C)
{
//Daca depaseste lungimea maxima, nu adauga nimic
TInteger NBS;
 if (S->Len >= S->MaxLen)
   {
    return ;
   }
//Realoca bufferul daca e nevoie
 NBS = (((S->Len + 1) >> 8) + 1) << 8;
 if (NBS != S->BuffSize)
   {
    S->Data = (PChar)(ReAllocateMemory(S->Data,NBS));
   }
//Adauga caracterul la sfarsit
 S->Data[S->Len] = C;
 S->Len += 1;
 S->Data[S->Len] = 0;
}

void DeleteLastCharOfWritingString(PWritingString S)
{
//Realoca bufferul daca e nevoie
 TInteger NBS = (((S->Len) >> 8) + 1) << 8;
 if (NBS != S->BuffSize)
   {
    S->Data = (PChar)(ReAllocateMemory(S->Data,NBS));
   }
//Sterge ultimul caracter, daca exista cel putin unu
 S->Len -= 1;
 if (S->Len < 0)
   {
    S->Len = 0;
   }
 S->Data[S->Len] = 0;
}

void CopyWritingString(PWritingString To,PWritingString From)
{
//Daca se face copierea in acelasi input
 if (To == From)
   {
//Nu copiaza nimic
    return;
   }
//Elibereaza vechiul string
 FreeMemory(To->Data);
//Face copia
 To->BuffSize = From->BuffSize;
 To->Len = From->Len;
 To->Data = (PChar)(AllocateMemory(To->BuffSize));
 StringCopy(To->Data,From->Data);
 To->MaxLen = From->MaxLen;
}

void DestroyWritingString(PWritingString S)
{
//Elibereaza memoria
 FreeMemory(S->Data);
 FreeMemory(S);
}

#include <Windows.h>

void SetTitle(PChar Title)
{
//Windows ONLY
    SetConsoleTitle(Title);
}

static SOCKET s;

void InitNetworking(PChar DestinationIP,TInteger16 Port)
{
    WSADATA wsaData;
    WORD version;
    int error;
    u_long iMode;
    struct sockaddr_in RecvAddr;

    version = MAKEWORD(2,0);
    error = WSAStartup(version,&wsaData);

    s = socket(AF_INET,SOCK_DGRAM,0);

    iMode = 1;
    ioctlsocket(s,FIONBIO,&iMode);

    RecvAddr.sin_family = AF_INET;
    RecvAddr.sin_port = htons(Port);
    RecvAddr.sin_addr.s_addr = inet_addr((const char *)(DestinationIP));

    error = bind(s, (SOCKADDR *) & RecvAddr, sizeof (RecvAddr));
}

void SendPacket(PChar DestinationIP,TInteger16 Port,TPointer Data,TInteger Size)
{
    struct sockaddr_in server_addr;

    memset(&server_addr,0,sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = inet_addr((const char *)(DestinationIP));
    server_addr.sin_port = htons(Port);

    sendto(s,(const char *)(Data),(int)(Size),0,(struct sockaddr *)(&server_addr),sizeof(server_addr));
}

void RecvPacket(PChar SourceIP,PInteger16 Port,TPointer Data,PInteger Size)
{
    struct sockaddr_in server_addr;
    int slen = sizeof(server_addr);
//    int error;

    memset(&server_addr,0,sizeof(server_addr));

    (*Size) = ((TInteger)(recvfrom(s,(char *)(Data),(int)(*Size),0,(struct sockaddr *)(&server_addr),&slen)));

    if ((*Size) >= 0)
    {
        sprintf(SourceIP,"%d.%d.%d.%d",server_addr.sin_addr.S_un.S_un_b.s_b1,server_addr.sin_addr.S_un.S_un_b.s_b2,
                                       server_addr.sin_addr.S_un.S_un_b.s_b3,server_addr.sin_addr.S_un.S_un_b.s_b4);
        (*Port) = ntohs(server_addr.sin_port);
    }

//    error = WSAGetLastError();
}

void CloseNetworking(void)
{
    closesocket(s);
    WSACleanup();
}

#endif
